<script lang="ts">
	import 'leaflet/dist/leaflet.css'
	import { createEventDispatcher, setContext, onMount } from 'svelte'

	const dispatch = createEventDispatcher()

	export let bounds
	export let view
	export let zoom

	let map
	let mapElement

	onMount(async () => {
		const Leaflet = await import('leaflet')

		map = Leaflet.map(mapElement)
		map.on('zoom', (e) => dispatch('zoom', e))
		invalidateView()
		Leaflet.tileLayer(
			'https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}{r}.png',
			{
				attribution: '',
				subdomains: 'abcd',
				maxZoom: 14
			}
		).addTo(map)

        return () => {
            map.remove()
        }
	})

	export const invalidateView = () =>
		bounds ? map?.fitBounds(bounds) : map?.setView(view, zoom)

	$: if (bounds || map || view || zoom) invalidateView()

	export const invalidateSize = () => map?.invalidateSize()

	export const getMap = () => map

	setContext('layerGroup', getMap)
	setContext('layer', getMap)
	setContext('map', getMap)
</script>

<div bind:this={mapElement}>
	{#if map}
		<slot {map} />
	{/if}
</div>

<style>
	:global(.leaflet-control-container) {
		position: static;
	}

	div {
		@apply w-full h-full;
	}
</style>
